---
- name: Create dirictories
  ansible.builtin.file:
    path: "{{ item }}"
    state: directory
    mode: "0755"
  with_items:
    - "{{ _postgresql_exporter_paths.values() | list }}"

- name: Download postgresql exporter tarball
  ansible.builtin.get_url:
    url: "{{ _postgresql_exporter_download_tarball_url }}"
    dest: "{{ _postgresql_exporter_paths.downloads }}/{{ _postgresql_exporter_download_tarball_url | basename }}"
    checksum: "sha256:{{ _postgresql_exporter_checksum_url }}"
    mode: "0644"

- name: Extract postgresql exporter
  ansible.builtin.unarchive:
    src: "{{ _postgresql_exporter_paths.downloads }}/{{ _postgresql_exporter_download_tarball_url | basename }}"
    dest: "{{ _postgresql_exporter_paths.downloads }}"
    remote_src: true

- name: Copy postgresql exporter binary
  ansible.builtin.copy:
    src: "{{ _postgresql_exporter_paths.downloads }}/{{ _postgresql_exporter_download_tarball_url | basename | splitext | first | splitext | first }}/postgres_exporter"
    dest: "{{ _postgresql_exporter_paths.bin }}"
    owner: "{{ postgresql_exporter_user }}"
    mode: "0744"
    remote_src: true

- name: Copy systemd service
  ansible.builtin.template:
    src: postgresql-exporter.service.j2
    dest: /etc/systemd/system/postgresql-exporter.service
    mode: "0644"
    owner: root
  notify:
    - Reload systemd daemon
    - Restart postgresql exporter service

- name: Start postgresql exporter service
  ansible.builtin.systemd_service:
    name: postgresql-exporter
    state: started
    enabled: true
